Skip to main content

Budget

View as Markdown

BudgetConfiguration object

budget_configuration_idstringuuidPublic Preview

<Databricks> budget configuration ID.

account_idstringuuidPublic Preview

<Databricks> account ID.

create_timeint64Public Preview

Creation time of this budget configuration.

update_timeint64Public Preview

Update time of this budget configuration.

alert_configurationsarray of objectPublic Preview

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
alert_configuration_idstringuuidPublic Preview

<Databricks> alert configuration ID.

time_periodstringPublic Preview

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestringPublic Preview

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestringPublic Preview

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstringPublic Preview

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of objectPublic Preview

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_configuration_idstringuuidPublic Preview

<Databricks> action configuration ID.

action_typestringPublic Preview

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstringPublic Preview

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobjectPublic Preview

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobjectPublic Preview

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstringPublic Preview

Values:

  • IN
valuesarray of int64Public Preview
tagsarray of objectPublic Preview

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystringPublic Preview
valueobjectPublic Preview
Show child attributesHide child attributes
operatorstringPublic Preview

Values:

  • IN
valuesarray of stringPublic Preview
display_namestringPublic Preview

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Get budget Public Preview

GET /api/2.1/accounts/{account_id}/budgets/{budget_id}

Gets a budget configuration for an account. Both account and budget configuration are specified by ID.

API scopes: billing

Parameters

account_idstringuuidRequiredpath

<Databricks> account ID.

budget_idstringuuidRequiredpath

The budget configuration ID

Response

budgetobject
Show child attributesHide child attributes
budget_configuration_idstringuuid

<Databricks> budget configuration ID.

account_idstringuuid

<Databricks> account ID.

create_timeint64

Creation time of this budget configuration.

update_timeint64

Update time of this budget configuration.

alert_configurationsarray of object

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
alert_configuration_idstringuuid

<Databricks> alert configuration ID.

time_periodstring

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestring

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestring

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstring

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of object

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_configuration_idstringuuid

<Databricks> action configuration ID.

action_typestring

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstring

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobject

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobject

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstring

Values:

  • IN
valuesarray of int64
tagsarray of object

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystring
valueobject
display_namestring

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Get all budgets Public Preview

GET /api/2.1/accounts/{account_id}/budgets

Gets all budgets associated with this account.

API scopes: billing

Parameters

account_idstringuuidRequiredpath

<Databricks> account ID.

page_tokenstringquery

A page token received from a previous get all budget configurations call. This token can be used to retrieve the subsequent page. Requests first page if absent.

Response

Returns a list of BudgetConfiguration objects.

Create new budget Public Preview

POST /api/2.1/accounts/{account_id}/budgets

Create a new budget configuration for an account. For full details, see https://docs.databricks.com/en/admin/account-settings/budgets.html.

API scopes: billing

Parameters

account_idstringuuidRequiredpath

<Databricks> account ID.

Request body

budgetobjectRequired

Properties of the new budget configuration.

Show child attributesHide child attributes
alert_configurationsarray of object

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
time_periodstring

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestring

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestring

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstring

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of object

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_typestring

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstring

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobject

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobject

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstring

Values:

  • IN
valuesarray of int64
tagsarray of object

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystring
valueobject
display_namestring

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Response

budgetobject

The created budget configuration.

Show child attributesHide child attributes
budget_configuration_idstringuuid

<Databricks> budget configuration ID.

account_idstringuuid

<Databricks> account ID.

create_timeint64

Creation time of this budget configuration.

update_timeint64

Update time of this budget configuration.

alert_configurationsarray of object

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
alert_configuration_idstringuuid

<Databricks> alert configuration ID.

time_periodstring

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestring

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestring

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstring

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of object

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_configuration_idstringuuid

<Databricks> action configuration ID.

action_typestring

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstring

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobject

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobject

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstring

Values:

  • IN
valuesarray of int64
tagsarray of object

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystring
valueobject
display_namestring

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Modify budget Public Preview

PUT /api/2.1/accounts/{account_id}/budgets/{budget_id}

Updates a budget configuration for an account. Both account and budget configuration are specified by ID.

API scopes: billing

Parameters

account_idstringuuidRequiredpath

<Databricks> account ID.

budget_idstringRequiredpath

The <Databricks> budget configuration ID.

Request body

budgetobjectRequired

The updated budget. This will overwrite the budget specified by the budget ID.

Show child attributesHide child attributes
budget_configuration_idstringuuid

<Databricks> budget configuration ID.

alert_configurationsarray of object

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
alert_configuration_idstringuuid

<Databricks> alert configuration ID.

time_periodstring

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestring

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestring

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstring

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of object

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_configuration_idstringuuid

<Databricks> action configuration ID.

action_typestring

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstring

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobject

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobject

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstring

Values:

  • IN
valuesarray of int64
tagsarray of object

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystring
valueobject
display_namestring

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Response

budgetobject

The updated budget.

Show child attributesHide child attributes
budget_configuration_idstringuuid

<Databricks> budget configuration ID.

account_idstringuuid

<Databricks> account ID.

create_timeint64

Creation time of this budget configuration.

update_timeint64

Update time of this budget configuration.

alert_configurationsarray of object

Alerts to configure when this budget is in a triggered state. Budgets must have exactly one alert configuration.

Show child attributesHide child attributes
alert_configuration_idstringuuid

<Databricks> alert configuration ID.

time_periodstring

The time window of usage data for the budget.

Values:

  • MONTH
trigger_typestring

The evaluation method to determine when this budget alert is in a triggered state.

Values:

  • CUMULATIVE_SPENDING_EXCEEDED
quantity_typestring

The way to calculate cost for this budget alert. This is what quantity_threshold is measured in.

Values:

  • LIST_PRICE_DOLLARS_USD
quantity_thresholdstring

The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on quantity_type.

action_configurationsarray of object

Configured actions for this alert. These define what happens when an alert enters a triggered state.

Show child attributesHide child attributes
action_configuration_idstringuuid

<Databricks> action configuration ID.

action_typestring

The type of the action.

Values:

  • EMAIL_NOTIFICATION
  • BLOCK_USAGE Beta
targetstring

Target for the action. For example, an email address.

scope_typestringBeta

How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.

Values:

  • ALERT_CONFIGURATION_SCOPE_TYPE_SHARED
  • ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
principal_overridesarray of objectBeta

Per-principal threshold overrides for this alert. Only applies to per-user alerts (scope_type = ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.

Show child attributesHide child attributes
principal_idint64Beta

Account-level principal id (user, group, or service principal).

override_thresholdstringBeta

Dollar amount that overrides the parent alert's quantity_threshold for this principal.

filterobject

Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.

Show child attributesHide child attributes
workspace_idobject

If provided, usage must match with the provided <Databricks> workspace IDs.

Show child attributesHide child attributes
operatorstring

Values:

  • IN
valuesarray of int64
tagsarray of object

A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.

Show child attributesHide child attributes
keystring
valueobject
display_namestring

Human-readable name of budget configuration. Max Length: 128

resource_typestringBeta

The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.

Values:

  • BUDGET_RESOURCE_TYPE_ALL_RESOURCES
  • BUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY

Delete budget Public Preview

DELETE /api/2.1/accounts/{account_id}/budgets/{budget_id}

Deletes a budget configuration for an account. Both account and budget configuration are specified by ID. This cannot be undone.

API scopes: billing

Parameters

account_idstringuuidRequiredpath

<Databricks> account ID.

budget_idstringuuidRequiredpath

The <Databricks> budget configuration ID.